%%%%%%%%%%%%%%%%% CODE WRITTEN BY YULIYA TARABALKA
%%%%%%%%%%%%%%%%% (yuliya.tarabalka@inria.fr)
%%%%%%%%%%%% DO NOT DISTRIBUTE, ONLY FOR INTERNAL COLLABORATION!!! %%%%%%%%%%%%%%%%%

clear all;
close all;
clc;


%width and height of the image
W = 340;  % width or the number of columns of an image
H = 610; % Height or number of rows of the image
B = 103; % the Breadth or the number of bands for providing info about the image
imagesize=H*W; % Size of the image or the number of pixels 
nPixels = H*W;

n=50; % number of pixels taken for each class for the creation of Test and the training Map

nclasses = 9;% number of classes


pathdata='/Users/xxx/data/';

p=genpath('/Users/xxx/SVM-KM/');
addpath(p);

p2=genpath('/Users/xxx/gco-v3/matlab/');
addpath(p2);


%load the image
load '/Users/xxx/PaviaU.mat';

%load ground-truth
load '/Users/xxx/PaviaU_gt.mat';


%load 'C:\Users\arana\Desktop\inria_file\epsilon.mat';
paviaU_scaled = 2*(paviaU - min(paviaU(:)))/(max(paviaU(:)) - min(paviaU(:)))-1 ;% Scaling the image where the max & the min values are 1 and -1 respectively 

TrainingMap = uint8(zeros(H,W));% initializing the training map
TestMap = uint8(zeros(H,W));% initializing the test map

TrainData=double(zeros(n*nclasses, B));% data for all the pixels of training map belonging to 1- 9 classes , each pixel is represented by one row with B column data 
currvectindex = 1;

nTest = 0;

%creation of the test and the training map 
for ind_clas = 1:nclasses   
   currentmap = (paviaU_gt == ind_clas);% currentmap is showing the existance of Current ind_class with value as 1 for only those pixel position where the pavia_gt becomes equal to current class, 
   ncurrentmap = length(find(currentmap==1));% ncurrentmap is an integral number,which actually represents the total number of pixels with current ind_class 
   trainindex = randperm(ncurrentmap);%generation of an random array (representing the pixel positions) of size of ncurrentmap
   trainindex = trainindex(1:n);% taking only first n number of pixel positions 
   trainindex = sort(trainindex);% sorting so as to move in the inreasing order of positions i.e left to right

   currindex = 1;
   currtrainindex = 1;
   currtrainnumber = trainindex(currtrainindex);%initialization with first choosen random position
   
   for ind_height = 1:H
       for ind_width = 1:W
          if (currentmap(ind_height, ind_width) > 0)% if the pixel belongs to a particular class 1-9 as per currentmap built
              if (currindex == currtrainnumber)&&(currtrainindex<(n+1))%if a selected random postion is same as the current index and the number of pixels has not exceeded the number choosen i.e n   
                  TrainingMap(ind_height, ind_width) = ind_clas;% current position in the map is marked as that class
                  TrainData(currvectindex,:) = reshape(paviaU_scaled(ind_height, ind_width, :),1,B);% the data corresponding to that pixels is retrieved from the original scaled image and stored
                  currvectindex = currvectindex+1;%index incrementation for the Traindata
                  currtrainindex = currtrainindex + 1;% index incrementation in trainindex array
                  if (currtrainindex<(n+1)) currtrainnumber = trainindex(currtrainindex); end % currtrainnumber is updated
              else % then test map is created with all classed 1-9
                  TestMap(ind_height, ind_width) = ind_clas;
                  nTest=nTest+1; % recording the number of pixels marked with some class value
              end %if (currindex == currtrainnumber)
              currindex = currindex+1;% current index of te training map is updated 
          end % if (currentmap(ind_height, ind_width) > 0)
       end %for ind_width = 1:W
   end % for ind_height = 1:H
end % for the classes

TrainLabels = [1*ones(1,n) 2*ones(1,n) 3*ones(1,n), 4*ones(1,n) 5*ones(1,n) 6*ones(1,n), 7*ones(1,n) 8*ones(1,n) 9*ones(1,n)]';% 1*360 array showing the labels for 9 classes

%create test vectors
TestData=double(zeros(nTest, B)); % initializing the test data matrix
TestLabels = double(zeros(nTest,1));%initializing the test label matrix
currTestIndex = 1;

 for ind_height = 1:H
       for ind_width = 1:W
          if (TestMap(ind_height, ind_width) > 0)% if the pixel belongs to some class 
              TestData(currTestIndex,:) = reshape(paviaU_scaled(ind_height, ind_width, :),1,B);% the data is retrieved and stored for that corresponsing pixel
              TestLabels(currTestIndex) = TestMap(ind_height, ind_width);%labels are also stored corresponding to the pixel value in the testmap
              currTestIndex = currTestIndex + 1;
          end
       end
 end

%map for the original data image is created (further used for the classification)
currMapIndex = 1;
MapData=double(zeros(H*W, B));% initializng the mapdata for original data image
MapLabels = double(ones(H*W,1));% initializng the maplabel for original data image
MapData=reshape(paviaU_scaled,H*W,B);%creation of the map data with rows representing the number of pixels and their columns contain their corresponding band information.

%%%%SVM classification%%%%


%SVM on the input data
model = svmtrain(TrainLabels, TrainData, '-c 512 -g .125 -b 1');% the svm (multiclass and radial basis kernal type) is trained here using the training data and training label(created above) and in returns gives a training model with cost,gamma and probability estimate coefficients 
[predict_label, accuracy, prob_estimates] = svmpredict(TestLabels, TestData, model, '-b 1');% the svm using the test data to check the model accuracy by predicting the labels and also providing the probabilities estimates

[predict_labelM, accuracyM, prob_estimatesM] = svmpredict(MapLabels, MapData, model, '-b 1');% svm is using the mapdata from the original scaled image and the model created 
predict_labelM2D = reshape(predict_labelM,H,W);%reshaping the labeling in a H*W matrix 
figure; imagesc(predict_labelM2D);

prob_estimatesM2 = reshape(prob_estimatesM,H,W,nclasses);%reshaping the probablities of pixels(in H*W*9) for the 9 classes as breadth.
figure; imagesc(prob_estimatesM2(:,:,1));


%################Graph cut################
%#########################################
h = GCO_Create(nPixels,nclasses);%an object is created with npixels and their nclasses as labels 

potentials = int32(double(20000.0.*(-log(prob_estimatesM)))');% potential determines which pixel has which strong potential label(the lesser the vale the more stronger the label) 


GCO_SetDataCost(h, potentials);%determines pixels potential(likelihood) towards the respective classes .... weights to t-links 


interactions = sparse(nPixels, nPixels);%the interactivness or the liklihood of a pixel with other pixels 

%compute interactions

currindex = 1;

for ind_width = 1:W
    for ind_height = 1:H % for a particular pixel position
        %indexes of 4 neighbors
        index4 = currindex + 1;
        index2 = currindex + H;
        index1 = index2 - 1;
        index3 = index2 + 1;
        %the 4 neighbourhood positions are
        indw1 = ind_width+1; indw2 = indw1; indw3 = indw2; indw4 = ind_width;
        indh1 = ind_height - 1; indh2 = ind_height; indh3 = ind_height + 1; indh4 = indh3;
        
       
        currvector = reshape(paviaU_scaled(ind_height, ind_width,:),103,1);% current pixel's band information is taken out in the currvector 

            %neighbors 1-3
            if (indw1 < W)
                %neighbor 1
                if (indh1 > 0)% if indh1 is less then 0 then the current pixel lies in the first row
                    currweight = 0;
                    sum_currvec =0;sum_scaledvec=0;
                    P=0;
                    Q=0;
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        sum_currvec = sum_currvec + abs(currvector(ind_band)) ;
                        sum_scaledvec = sum_scaledvec + abs(paviaU_scaled(indh1, indw1, ind_band));     
                    end %for ind_band = 1:B
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        P = abs(currvector(ind_band))/(sum_currvec);
                        Q = abs(paviaU_scaled(indh1, indw1, ind_band))/sum_scaledvec;
                        currweight = currweight + (P*log2(P/Q) + Q*log2(Q/P));

                    end %for ind_band = 1:B
                    %currweight = acos (double(num_SAM/(sum_currvec*sum_scaledvec)));

                    currweight = 15000*exp(-(currweight)/((double(B))));%corelation gaussian
                    interactions(currindex, index1) = int32(currweight);% updating the interaction matrix with the calculated weights with ts first neighbour 
                    interactions(index1, currindex) = int32(currweight);% maintaining the symmetricity of the matrix
                end %if (indh1 > 0)



                %neighbor2
                    currweight = 0;
                    sum_currvec =0;sum_scaledvec=0;
                    P=0;Q=0;
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        sum_currvec = sum_currvec + abs(currvector(ind_band)) ;
                        sum_scaledvec = sum_scaledvec + abs(paviaU_scaled(indh2, indw2, ind_band));     
                    end %for ind_band = 1:B
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        P = abs(currvector(ind_band))/(sum_currvec);
                        Q = abs(paviaU_scaled(indh2, indw2, ind_band))/sum_scaledvec;
                        currweight = currweight + (P*log2(P/Q) + Q*log2(Q/P));

                    end %for ind_band = 1:B

                    currweight = 15000*exp(-(currweight)/((double(B))));% same updatation as above
                    interactions(currindex, index2) = int32(currweight);
                    interactions(index2, currindex) = int32(currweight);

                if (indh3 <= H)% only check for the row number with in case if the current pixel is the pixel in the last row
                    currweight = 0;
                    sum_currvec =0;sum_scaledvec=0;
                    P=0;Q=0;
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        sum_currvec = sum_currvec + abs(currvector(ind_band)) ;
                        sum_scaledvec = sum_scaledvec + abs(paviaU_scaled(indh3, indw3, ind_band));     
                    end %for ind_band = 1:B
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        P = abs(currvector(ind_band))/(sum_currvec);
                        Q = abs(paviaU_scaled(indh3, indw3, ind_band))/sum_scaledvec;
                        currweight = currweight + (P*log2(P/Q) + Q*log2(Q/P));       
                    end %for ind_band = 1:B

                    currweight = 15000*exp(-(currweight)/((double(B))));
                    interactions(currindex, index3) = int32(currweight);
                    interactions(index3, currindex) = int32(currweight);% same as above
                end %if (indh1 > 0)    

            end %if (indw1 < W)

            if (indh4 <= H)
                    currweight = 0;
                    sum_currvec =0;sum_scaledvec=0;
                    P=0;Q=0;
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        sum_currvec = sum_currvec + abs(currvector(ind_band)) ;
                        sum_scaledvec = sum_scaledvec + abs(paviaU_scaled(indh4, indw4, ind_band));     
                    end %for ind_band = 1:B
                    for ind_band = 1:B % takes the total relationship with its first neighbour with taking all bands into consideration
                        P = abs(currvector(ind_band))/(sum_currvec);
                        Q = abs(paviaU_scaled(indh4, indw4, ind_band))/sum_scaledvec;
                        currweight = currweight + (P*log2(P/Q) + Q*log2(Q/P));

                    end %for ind_band = 1:B
                    %currweight = acos (double(num_SAM/(sum_currvec*sum_scaledvec)));
                    currweight = 15000*exp(-(currweight)/((double(B))));
                    interactions(currindex, index4) = int32(currweight);
                    interactions(index4, currindex) = int32(currweight);
            end %if (indh4 <= H) % same as neighbour3

            currindex = currindex+1;
        
    end %for ind_height = 1:H
end %for ind_width = 1:W


GCO_SetNeighbors(h, interactions);%connected weights are applied representing the pixels relationship in the graph

GCO_Expansion(h); % application of the alpha expansion algorithm for computing the optimized labelling

GClabels = GCO_GetLabeling(h);%obtaining the optimized labeling

GClabels = reshape(GClabels,H,W);%transforming the labeling array into a matrix of H*w size
figure; imagesc(GClabels); colorbar;


GCO_Delete(h);% the graph is deleted here 

CSaccuracy_GC = zeros(nclasses,1);
confmatrix_GC = zeros(nclasses,nclasses);
nTestPerClass = zeros(nclasses,1);
AA_GC = 0; OA_GC = 0;

CSaccuracy = zeros(nclasses,1);
confmatrix = zeros(nclasses,nclasses);
AA = 0; OA = 0;

%compute accuracy
for ind_height = 1:H
       for ind_width = 1:W
          if (TestMap(ind_height, ind_width) > 0)% for the testmap if the pixel belongs to any class 1-9
              trueclass=TestMap(ind_height, ind_width);% then trueclass represents the orignal class of the pixel
              nTestPerClass(trueclass) = nTestPerClass(trueclass) + 1;%testperclass is incremented for that class
              confmatrix_GC(trueclass, GClabels(ind_height, ind_width)) = confmatrix_GC(trueclass, GClabels(ind_height, ind_width)) + 1;% in the same way the confmatric_Gc is also incremented for that particular true class ,with main motivation of checking with respect to the graph cut labeling 
              confmatrix(trueclass, predict_labelM2D(ind_height, ind_width)) = confmatrix(trueclass, predict_labelM2D(ind_height, ind_width)) + 1;%similarly as above,with main motivation of checking with respect to the svm predicted labeling
          end
       end
end

for ind_class = 1:nclasses
   CSaccuracy_GC(ind_class) = double(confmatrix_GC(ind_class, ind_class))/double(nTestPerClass(ind_class));%normalized diagonal values are extracted for graph-cut class accuracy measurements 
   OA_GC = OA_GC + double(confmatrix_GC(ind_class, ind_class));
   AA_GC = AA_GC + CSaccuracy_GC(ind_class);
   
   CSaccuracy(ind_class) = double(confmatrix(ind_class, ind_class))/double(nTestPerClass(ind_class));%normalized diagonal values are extracted for prediction class accuracy measurements 
   OA = OA + double(confmatrix(ind_class, ind_class));
   AA = AA + CSaccuracy(ind_class);
end

OA_GC = OA_GC/double(nTest)%overall accuracy of the graphcut approach is estimated
AA_GC = AA_GC/double(nclasses)%average accuracy of the graphcut approach is estimated

OA = OA/double(nTest)%overall accuracy of the prediction approach is estimated
AA = AA/double(nclasses)%average accuracy of the prediction approach is estimated

outmap = uint8(zeros(H,W,3));%outmap building with color values for the 9 classes
colR = [192 0     0  0  255 165  128  255 255];
colG = [192 255  255 128 0   82  0    0    255];
colB = [192 0    255 0  255  41  128  0    0];

for ind_height = 1:H
       for ind_width = 1:W
           cl = GClabels(ind_height, ind_width);
           outmap(ind_height, ind_width, 1) = colR(cl);
           outmap(ind_height, ind_width, 2) = colG(cl);
           outmap(ind_height, ind_width, 3) = colB(cl);
       end
end
%hence the for each pixel according to its label the color is provided
%according to its class
figure; imshow(outmap);




